#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <bitset>

using namespace std;

#define fst first
#define snd second

constexpr int maxn = 510;
constexpr int lo = 70;

vector<int> p[maxn];
vector<int> q[maxn];
bitset<maxn> p1[maxn][lo];
bitset<maxn> q1[maxn][lo];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, u;
        cin >> a >> b >> u;
        --a;
        --b;
        (u ? q : p)[a].push_back(b);
    }
    for (int i = 0; i < n; ++i) {
        for (auto to: p[i]) {
            p1[i][0][to] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (auto to: q[i]) {
            q1[i][0][to] = 1;
        }
    }
    for (int i = 1; i < lo; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                if (p1[j][i-1][k]) {
                    p1[j][i] |= q1[k][i-1];
                }
                if (q1[j][i-1][k]) {
                    q1[j][i] |= p1[k][i-1];
                }
            }
        }
    }
    bool inv = 0;
    unsigned long long res = 0;
    bitset<maxn> curb;
    curb[0] = 1;
    for (int cur = 62; cur >= 0; --cur) {
        if (!inv) {
            bitset<maxn> z;
            for (int i = 0; i < n; ++i) {
                if (curb[i]) {
                    z |= p1[i][cur];
                }
            }
            if (z.any()) {
                curb = z;
                res += 1ull<<cur;
                inv = !inv;
            }
        } else {
            bitset<maxn> z;
            for (int i = 0; i < n; ++i) {
                if (curb[i]) {
                    z |= q1[i][cur];
                }
            }
            if (z.any()) {
                curb = z;
                res += 1ull<<cur;
                inv = !inv;
            }
        }
    }
    if (res > 1000000000000000000) {
        cout << "-1\n";
        return 0;
    }
    cout << res << '\n';
    return 0;
}
