#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define eb emplace_back

const int MOD = 1e9 + 7;

struct segtree {
    int n;
    vector<set<int>> v;

    void modify(int l, int r, int x) {
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) v[l++].insert(x);
            if (r & 1) v[--r].insert(x);
        }
    }

    void modify2(int l, int r, int x) {
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) v[l++].erase(x);
            if (r & 1) v[--r].erase(x);
        }
    }

    int query(int t) {
        t += n;
        int ans = -1;
        while (t > 0) {
            if (!v[t].empty()) {
                ans = max(ans, *(--v[t].end()));
            }
            t >>= 1;
        }
        return ans;
    }

    segtree(int n): n(n), v(2 * n) {}
};

void modadd(int &to, int x) {
    to += x;
    to %= MOD;
}

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int h, w, n;
    cin >> h >> w >> n;
    vector<tuple<int, int, int, int>> v;
    for (int i = 0; i < n; i++) {
        int u, l, r, s;
        cin >> u >> l >> r >> s;
        v.eb(u, l, r, s);
    }
    sort(v.begin(), v.end());
    vector<tuple<int, int, int, int, int>> t;
    vector<int> ans(n, 0);
    for (int i = 0; i < n; i++) {
        int u, l, r, s;
        tie(u, l, r, s) = v[i];
        t.eb(u, 0, l, r, i);
        t.eb(u + s + 1, 1, l, r, i);
        t.eb(u, 2, l, r, i);
    }
    for (int i = 1; i <= w; i++) {
        t.eb(h + 1, 2, -1, -1, -i);
    }
    sort(t.begin(), t.end());
    segtree sg(w + 1);
    int pw = 0;
    for (auto &it : t) {
        int u, tp, l, r, num;
        tie(u, tp, l, r, num) = it;
        if (tp == 0) {
            sg.modify(l, r + 1, num);
        } else if (tp == 1) {
            sg.modify2(l, r + 1, num);
        } else if (tp == 2) {
            int f1, f2;
            if (num < 0) {
                f1 = -num;
                f2 = -num;
            } else {
                if (l > 1) f1 = l - 1;
                else f1 = r + 1;
                if (r < w) f2 = r + 1;
                else f2 = l - 1;
            }
            f1 = sg.query(f1);
            if (num < 0) {
                if (f1 == -1) modadd(pw, 1);
                else modadd(pw, ans[f1]);
                //cerr << pw << endl;
            } else {
                f2 = sg.query(f2);
                if (f1 == -1) modadd(ans[num], 1);
                else modadd(ans[num], ans[f1]);
                if (f2 == -1) modadd(ans[num], 1);
                else modadd(ans[num], ans[f2]);
            }
        }
    }
    cout << pw << endl;
    return 0;
}
