#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int n, ans = 0;
vector <int> col;
vector <vector <int> > g;

inline void dfs(int node, int par = 0, int pcol = 0)
{
    int color = 1;
    for (int i = 0; i < (int)g[node].size(); i++)
    {
        int to = g[node][i];
        if (to == par)
            continue;

        while (color == col[node] || color == pcol)
            color++;
        col[to] = color++;
    }

    for (int i = 0; i < (int)g[node].size(); i++)
    {
        int to = g[node][i];
        if (to != par)
            dfs(to, node, col[node]);
    }
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n;
    g.resize(n + 1);
    col.resize(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        int from, to;
        cin >> from >> to;

        g[from].push_back(to);
        g[to].push_back(from);
    }

    for (int i = 1; i <= n; i++)
        ans = max(ans, (int)g[i].size() + 1);

    col[1] = 1;
    dfs(1);

    cout << ans << '\n';
    for (int i = 1; i <= n; i++)
        cout << col[i] << ' ';
    return 0;
}
