#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

struct edge
{
    int to, f, c, ret;
    node(int To, int F, int C, int Ret)
    {
        to = To;
        f = F;
        c = C;
        ret = Ret;
    }
};

vector <int> exc, h, current;
vector <vector <edge> > g;

bool flag;
inline void push(int v, int u)
{
    int to = g[v][u].to;
    if (exc[v] && g[v][u].f < g[v][u].c && h[v] == h[to] + 1)
    {
        flag = true;
        int flow = min(exc[v], g[v][u].c - g[v][u].f);

        exc[v] -= flow;
        exc[to] += flow;
        g[v][u].f += flow;
        g[to][g[v][u].ret].f -= flow;
    }
}

inline void relabel(int v)
{
    int nh = 1e9;
    for (int u = 0; u < (int)g[v].size(); u++)
        if (g[v][u].f < g[v][u].c)
            nh = min(nh, h[g[v][u].to] + 1);
    h[v] = nh;
}

inline void discharge(int v)
{
    while (exc[v])
    {
        for (; current[v] < (int)g[v].size(); current[v]++)
        {
            push(v, current[v]);
            if (!exc[v])
                return;
        }
        current[v] = 0;
        relabel(v);
    }
}

int n, m, s = 0, t = 5000, cnt, N = 5000;
map <string, int> m1, m2, m3;
map <int, string> m4;
vector <string> a, b;

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n;
    a.resize(n + 1);
    b.resize(n + 1);
    cnt = n + 1;
    g.resize(5001);
    h.resize(5001, 0);
    exc.resize(5001, 0);
    current.resize(5001, 0);
    for (int i = 1; i <= n; i++)
    {
        g[s].push_back({i, 1, 1, (int)g[i].size()});
        g[i].push_back({s, 0, 1, (int)g[s].size() - 1});
        exc[i] = 1;

        string s1, s2;
        cin >> a[i] >> b[i];
        s1 += a[i][0], s1 += a[i][1], s1 += a[i][2];
        s2 += a[i][0], s2 += a[i][1], s2 += b[i][0];

        a[i] = s1, b[i] = s2;

        m1[s1]++, m2[s2]++;
    }

    for (int i = 1; i <= n; i++)
    {
        int it;
        if (m3.find(a[i]) == m3.end())
        {
            it = m3[a[i]] = cnt++;
            m4[it] = a[i];
            g[it].push_back({t, 0, 1, (int)g[t].size()});
            g[t].push_back({it, 1, 1, (int)g[it].size() - 1});
        }
        it = m3[a[i]];

        if (m1[a[i]] == 1)
        {
            g[i].push_back({it, 0, 1, (int)g[it].size()});
            g[it].push_back({i, 1, 1, (int)g[i].size() - 1});
        }

        if (m3.find(b[i]) == m3.end())
        {
            it = m3[b[i]] = cnt++;
            m4[it] = b[i];
            g[it].push_back({t, 0, 1, (int)g[t].size()});
            g[t].push_back({it, 1, 1, (int)g[it].size() - 1});
        }
        it = m3[b[i]];

        g[i].push_back({it, 0, 1, (int)g[it].size()});
        g[it].push_back({i, 1, 1, (int)g[i].size() - 1});
    }

    h[s] = 2 + n + (int)m3.size() + 2;
    exc[s] = 1e9;

    flag = true;
    while (flag)
    {
        flag = false;
        for (int i = 1; i < 5000; i++)
            discharge(i);
    }

    if (exc[t] != n)
        cout << "NO";
    else
    {
        cout << "YES\n";
        for (int i = 1; i <= n; i++)
        {
            for (int j = 0; j < (int)g[i].size(); j++)
            {
                int to = g[i][j].to;
                if (to != s && g[i][j].f == 1)
                    cout << m4[to] << '\n';
            }
        }
    }
    return 0;
}
