#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
const int MAXN = 1e5;
const long double EPS = 1e-9;

int n;
pair<long double, long double> coords[MAXN];

long double dobs(long double x){
    long double ans = 0;

    for (int i = 0; i < n; ++i){
        ans = max(ans, abs(coords[i].first - x) / coords[i].second);
    }

    return ans;
}

long double tern(){
    long double l = 0;
    long double r = 1e9 + 100;

    while (l + EPS < r){
        long double ll = l + (r - l) / 3;
        long double rr = r - (r - l) / 3;

        if (dobs(ll) > dobs(rr)){
            l = ll;
        } else {
            r = rr;
        }
        //cout << l << ' ' << r << endl;
    }

    return dobs(l);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for (int i = 0; i < n; ++i){
        cin >> coords[i].first;
    }

    for (int i = 0; i < n; ++i){
        cin >> coords[i].second;
    }

    cout.precision(20);
    cout << tern() << endl;

    return 0;
}
