#ifdef _DEBUG
#	include <iostream>
#	include <cstdio>
#	include <cmath>
#	include <vector>
#	include <string>
#	include <algorithm>
#	include <functional>
#	include <iomanip>
#else
#	include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

int dfs(int s, int n, vector<vector<int>> &a, vector<int> &col, int c)
{
	if (col[s] == -1)
		col[s] = c;
	else if (col[s] != c)
		return 0;
	else
		return 1;

	int s1 = (s + n) % n, res = 1;
	if (col[s1] == -1)
		res = res && dfs(s1, n, a, col, 1 - c);
	else if (col[s1] != 1 - c)
		return 0;

	if (c == 0)
		return res;

	for (int i = 0; i < a[s].size(); i++)
		res = res && dfs(a[s][i], n, a, col, 0);

	return res;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int n;
	cin >> n;

	vector<pair<pair<string, string>, int>> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first.first >> a[i].first.second;
		a[i].second = i;
	}

	for (int i = 0; i < n; i++)
	{
		a[i].first.first.erase(a[i].first.first.begin() + 3, a[i].first.first.end());
		a[i].first.second.erase(a[i].first.second.begin() + 1, a[i].first.second.end());
	}

	sort(a.begin(), a.end());

	vector<pair<string, int>> res(n);
	vector<string> alt(n);
	for (int i = 0; i < n; i++)
		if ((i == 0 || a[i].first.first != a[i - 1].first.first) && (i == n - 1 || a[i].first.first != a[i + 1].first.first))
		{
			res[a[i].second] = make_pair(a[i].first.first, 1);
			alt[a[i].second] = string() + a[i].first.first[0] + a[i].first.first[1] + a[i].first.second[0];
		}
		else
			res[a[i].second] = make_pair(string() + a[i].first.first[0] + a[i].first.first[1] + a[i].first.second[0], 0);

	vector<int> check(n);
	for (int i = 0; i < n; i++)
		check[i] = i;

	while (check.size() > 0)
	{
		int p = check.back();
		check.pop_back();
		for (int i = 0; i < n; i++)
			if (i != p && res[i].first == res[p].first)
				if (res[i].second == 0 && res[p].second == 0)
				{
					cout << "NO" << endl;
					return 0;
				}
				else if (res[i].second == 1 && res[p].second == 0)
				{
					res[i].first = alt[i];
					res[i].second = 0;
					check.push_back(i);
				}
				else if (res[i].second == 0 && res[p].second == 1)
				{
					res[p].first = alt[p];
					res[p].second = 0;
					check.push_back(p);
				}
	}

	vector<vector<int>> g(n * 2);
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			if (res[i].second && res[j].second)
			{
				if (res[i].first == res[j].first)
				{
					g[i].push_back(j);
					g[j].push_back(i);
				}

				if (res[i].first == alt[j])
				{
					g[i].push_back(j + n);
					g[j + n].push_back(i);
				}

				if (alt[i] == res[j].first)
				{
					g[i + n].push_back(j);
					g[j].push_back(i + n);
				}

				if (alt[i] == alt[j])
				{
					g[i + n].push_back(j + n);
					g[j + n].push_back(i + n);
				}
			}

	vector<int> col(n * 2, -1), t;
	for (int i = 0; i < n; i++)
		if (g[i].size() != 0)
		{
			t = col;

			if (!dfs(i, n, g, t, 1))
			{
				t = col;

				if (!dfs(i, n, g, t, 0))
				{
					cout << "NO" << endl;
					return 0;
				}
			}

			col.swap(t);
		}

	for (int i = 0; i < n; i++)
		if (col[i] == 0)
			res[i].first = alt[i];

	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++)
			if (res[i].first == res[j].first)
			{
				cout << "NO" << endl;
				return 0;
			}

	cout << "YES" << endl;
	for (int i = 0; i < n; i++)
		cout << res[i].first << endl;
}