#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <bitset>

using namespace std;

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define pii pair <int, int>
#define ll long long

const int MAXN = 505;
const int MAXLOG = 61;
const ll INF = 1e18;
vector <vector <bitset <MAXN> > > ok(MAXLOG, vector <bitset <MAXN> > (MAXN));
vector <vector <bitset <MAXN> > > nok(MAXLOG, vector <bitset <MAXN> > (MAXN));
vector <vector <bitset <MAXN> > > inv(MAXLOG, vector <bitset <MAXN> > (MAXN));
vector <vector <bitset <MAXN> > > ninv(MAXLOG, vector <bitset <MAXN> > (MAXN));

vector <vector <ll> > dok(MAXLOG, vector <ll> (MAXN, 0));
vector <vector <ll> > dinv(MAXLOG, vector <ll> (MAXN, 0));



int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		if (t == 0) {
			ok[0][u][v] = 1;
			nok[0][v][u] = 1;
		} else {
			inv[0][u][v] = 1; 
			ninv[0][v][u] = 1; 
		}
	}
	for (int it = 1; it < MAXLOG; ++it) {
		for (int i = 0; i < MAXN; ++i) {
			for (int j = 0; j < MAXN; ++j) {
				ok[it][i][j] = (ok[it - 1][i] & ninv[it - 1][j]) != 0;
				nok[it][j][i] = (ok[it - 1][i] & ninv[it - 1][j]) != 0;
				inv[it][i][j] = (inv[it - 1][i] & nok[it - 1][j]) != 0;
				ninv[it][j][i] = (inv[it - 1][i] & nok[it - 1][j]) != 0;
			}
		}
	}
	for (int j = 0; j < MAXN; ++j) {
		for (int k = 0; k < MAXN; ++k) {
			if (ok[0][j][k])
				dok[0][j] = 1;
			if (inv[0][j][k])
				dinv[0][j] = 1;
		}
	}
	for (int i = 0; i + 1 < MAXLOG; ++i) {
		for (int j = 0; j < MAXN; ++j) {
			dok[i + 1][j] = dok[i][j];
			dinv[i + 1][j] = dinv[i][j];
			for (int k = 0; k < MAXN; ++k) {
				if (ok[i][j][k])
					dok[i + 1][j] = max(dok[i + 1][j], (1ll << i) + dinv[i][k]);
				if (inv[i][j][k])
					dinv[i + 1][j] = max(dinv[i + 1][j], (1ll << i) + dok[i][k]);
			}
		}
	}
	long long ans = 0;
	for (int i = 0; i < MAXN; ++i)
		ans = max(ans, dok[MAXLOG - 1][i]);
	if (ans > INF)
		ans = -1;
	cout << ans << endl;
}