#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>

using namespace std;

typedef int int32_t;
#define int long long

const double eps = 1e-7;

vector<int> xs, vs;
int n;

bool check(double t) {
	vector<pair<double, int> > evs;
	for (int i = 0; i < n; i++) {
		evs.push_back(make_pair(xs[i] - vs[i] * t, 1));
		evs.push_back(make_pair(xs[i] + vs[i] * t, 2));
	}
	sort(evs.begin(), evs.end());
	int cb = 0;
	for (int i = 0; i < evs.size(); i++) {
		if (evs[i].second == 1)
			cb++;
		else
			cb--;

		if (cb == n)
			return true;
	}
	return false;
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	cin >> n;
	xs.resize(n);
	vs.resize(n);
	for (int i = 0; i < n; i++)
		scanf("%I64d", &xs[i]);
	for (int i = 0; i < n; i++)
		scanf("%I64d", &vs[i]);
	double l = 0, r = 1e9;
	for (int i = 0; i < 100; i++) {
		double m = (l + r) / 2.;
		if (check(m))
			r = m;
		else
			l = m;
	}
	cout.precision(10);
	cout << fixed << r << "\n";
}