#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <numeric>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = numeric_limits<ll>::max() / 2 - 1;
const ll mod = 1000000007;
const ld eps = 1e-8;
const ll maxn = 2234;
ll n;
vector<pair<string,string>> mas;
ll endp = 0;
map<string, vector<ll>> mp;
ll t[maxn];
ll f[maxn];
ll color[maxn];
ll pcolor = 1;
vector<ll> edges[maxn];
vector<ll> pedges[maxn];
vector<bool> ans;

bool used[maxn];
vector<ll> tps;
void topsort(ll v) {
	if(used[v]) return;
	used[v] = true;
	for(int i=0;i<edges[v].size();i++) {
		topsort(edges[v][i]);
	}
	tps.push_back(v);
}

void dfs(ll v) {
	if(used[v]) return;
	used[v] = true;
	color[v] = pcolor;
	for(int i=0;i<pedges[v].size();i++) {
		dfs(pedges[v][i]);
	}
}

void ae(ll v, ll u) {
	edges[v].push_back(u);
	pedges[u].push_back(v);
}

int run() {
	cin >> n;
	mas.resize(n);
	ans.resize(n);
	for(int i=0;i<n;i++) cin >> mas[i].first >> mas[i].second;
	for(int i=0;i<n;i++) {
		string s1 = mas[i].first.substr(0,3);
		string s2 = mas[i].first.substr(0,2) + mas[i].second.substr(0,1);
		mas[i].first = s1;
		mas[i].second = s2;
		mp[s1].push_back(i);
		mp[s2].push_back(i);
		t[i] = endp++;
		f[i] = endp++;
	}
	for(int i=0;i<n;i++) {
		for(auto j = mp[mas[i].first].begin(); j != mp[mas[i].first].end(); j++) {
			if(*j==i) continue;
			if(mas[*j].first == mas[i].first) {
				ae(t[i],f[*j]);
				ae(f[i],f[*j]);
			} else {
				ae(t[i],t[*j]);
			}
		}
		for(auto j = mp[mas[i].second].begin(); j != mp[mas[i].second].end(); j++) {
			if(*j==i) continue;
			if(mas[*j].first == mas[i].second) {
				ae(f[i],f[*j]);
			} else {
				ae(f[i],t[*j]);
			}
		}
	}
	for(int i=0;i<endp;i++) {
		if(!used[i]) topsort(i);
	}
	memset(used,0,sizeof(used));
	reverse(tps.begin(),tps.end());
	for(int i=0;i<tps.size();i++) {
		if(!used[tps[i]]) {
			dfs(tps[i]);
			pcolor++;
		}
	}
	for(int i=0;i<n;i++) {
		if(color[t[i]]==color[f[i]]) {
			cout << "NO";
			return 0;
		} else if(color[t[i]] > color[f[i]]) {
			ans[i] = false;
		} else {
			ans[i] = true;
		}
	}
	cout << "YES\n";
	for(int i=0;i<n;i++) {
		if(ans[i]) cout << mas[i].second << endl;
		else cout << mas[i].first << endl;
	}
	return 0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else

#endif
	run();
	return 0;
}