#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <numeric>
#include <stdlib.h>

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = numeric_limits<ll>::max() / 2 - 1;
const ll mod = 1000000007;
const ld eps = 1e-8;
const ll maxn = 200001;
ll n, m, k;
ll maxsz;
vector<ll> edges[maxn];
bool used[maxn];
bool ismark[maxn];
vector<vector<ll>> ans;

void dfs(ll v) {
	if(used[v]) return;
	used[v] = true;
	if(!ans.empty() && ans.back().size()<maxsz && !ismark[v]) {
		ans[ans.size()-1].push_back(v);
		ismark[v] = true;
	}
	for(int i=0;i<edges[v].size();i++) {
		if(!used[edges[v][i]]) {
			dfs(edges[v][i]);
			if(ans.back().size()==maxsz &&!ismark[v]) {
				ans.push_back(vector<ll>(1,v));
				ismark[v] = true;
			} else if(ans.back().size()!=maxsz){
				ans[ans.size()-1].push_back(v);
				ismark[v] = true;
			}
		}
	}
	if(ans.empty() || ans.back().size()==maxsz && !ismark[v]) {
		ismark[v] = true;
		ans.push_back(vector<ll>(1,v));
	}
}

int run() {
	cin >> n >> m >> k;
	maxsz = (2*n+k-1)/k;
	for(int i=0;i<m;i++) {
		ll a,b;
		cin >> a >> b;
		a--;
		b--;
		edges[a].push_back(b);
		edges[b].push_back(a);
	}
	dfs(0);
	for(int i=0;i<ans.size();i++) {
		cout << ans[i].size() << " ";
		for(int j=0;j<ans[i].size();j++) cout << ans[i][j]+1 << " ";
		cout << endl;
	}
	return 0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else

#endif
	run();
	return 0;
}