#include <bits/stdc++.h>
using namespace std;

const long long maxn = 512, logn = 70, inf = 1e18+1;

typedef bitset<maxn> t;

typedef vector<t> matrix;

long long n;

matrix operator*(matrix a, matrix b){
    matrix ans(n);
    for(long long i = 0; i < n; i++)
        for(long long j = 0; j < n; j++)
            ans[i][j] = 0;
    for(long long i = 0; i < n; i++)
        for(long long j = 0; j < n; j++)
            if(a[i][j])
                ans[i] |= b[j];
    return ans;
}

vector<t> a[logn], b[logn];

matrix f(long long t, bool r){
    if(t == 0){
        matrix ans(n);
        for(long long i = 0; i < n; i++)
            for(long long j = 0; j < n; j++)
                ans[i][j] = 0;
        for(long long i = 0; i < n; i++)
            ans[i][i] = 1;
        return ans;
    }
    else{
        long long l = 0;
        while((2ll<<l) <= t) l++;
        if(!r) return a[l]*f(t-(1ll<<l), !r);
        else return b[l]*f(t-(1ll<<l), !r);
    }
}

int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    clock_t start = clock();

    long long m;
    cin >> n >> m;

    t p;

    a[0].assign(n, p), b[0].assign(n, p);

    while(m--){
        long long u, v, type;
        cin >> u >> v >> type;
        u--, v--;
        if(type == 0) a[0][u][v] = 1;
        else b[0][u][v] = 1;
    }

    for(long long l = 1; l < logn; l++){
        a[l] = a[l-1]*b[l-1];
        b[l] = b[l-1]*a[l-1];
    }

    long long l = 0, r = inf;
    while(l < r){
        long long t = (l+r+1)/2;
        matrix ans = f(t, 0);
        bool good = 0;
        for(long long i = 0; i < n; i++)
            if(ans[i].count() > 0)
                good = 1;
        if(good) l = t;
        else r = t-1;
    }

    if(l == inf) cout << -1;
    else cout << l;

    return 0;
}
