#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;

#define TASK ""
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define for1(i, n) for (int i = 1; i <= (int)n; i++)
#define X first
#define Y second
#define mk make_pair
#define pk push_back
#define all(v) v.begin(), v.end()
#define TIME clock() * 1.0 / CLOCKS_PER_SEC

void solve();

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
	
#endif
	solve();
	return 0;
}

const int MAXN = (int)1e3 + 7;
const int INF = (int)1e9 + 7;

string a[MAXN][2];
unordered_map<string, vector<pii> > mp(MAXN);
vector<pii> g[MAXN][2];
bool used[MAXN][2], cant[MAXN][2];
set<pii> buf;

void add(pii p1, pii p2){
	g[p1.X][p1.Y].pk(p2);
	g[p2.X][p2.Y].pk(p1);
}

void no(){
	printf("NO");
	exit(0);
}

bool dfs(int v, int part){
	buf.insert(mk(v, part));
	used[v][part] = true;
	bool ok = !cant[v][part];
	forn(j, g[v][part].size()){
		int to_v = g[v][part][j].X;
		int to_part = g[v][part][j].Y;
		if (!used[to_v][to_part]){
			if (!dfs(to_v, to_part)){
				ok = false;
			}
		}
		else{
			if (v == to_v && part != to_part){
				if (buf.count(mk(to_v, to_part))){
					ok = false;
				}
			}
		}
	}
	return ok;
}

void solve(){
	int n;
	cin >> n;
	forn(i, n){
		string s, t;
		cin >> s >> t;
		a[i][0] = s.substr(0, 3);
		a[i][1] = s.substr(0, 2) + t.substr(0, 1);
		mp[a[i][0]].pk(mk(i, 0));
		mp[a[i][1]].pk(mk(i, 1));
	}
	for (auto it = mp.begin(); it != mp.end(); it++){
		forn(i, it->second.size()){
			forn(j, i){
				auto p1 = it->second[i];
				auto p2 = it->second[j];
				if (p1.Y != p2.Y){
					add(p1, mk(p2.X, p1.Y));
					add(p2, mk(p1.X, p2.Y));
				}
				if (p1.Y == p2.Y){
					if (p1.Y == 0){
						add(mk(p1.X, 1), mk(p2.X, 1));
						cant[p1.X][p1.Y] = true;
						cant[p2.X][p2.Y] = true;
					}
					else{
						add(mk(p1.X, 1), mk(p2.X, 0));
						add(mk(p1.X, 0), mk(p2.X, 1));
					}
				}
			}
		}
	}

	forn(i, n){
		forn(part, 2){
			if (!used[i][part]){
				buf.clear();
				if (!dfs(i, part)){
					for (auto it = buf.begin(); it != buf.end(); it++){
						cant[it->X][it->Y] = true;
					}
				}
			}
		}
	}
	forn(i, n){
		if (cant[i][0] && cant[i][1]){
			no();
		}
	}
	printf("YES\n");
	forn(i, n){
		string ans = (cant[i][0] ? a[i][1] : a[i][0]);
		cout << ans << '\n';
	}
}